//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "math.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ExPars"
#pragma link "ExFuncs"
#pragma link "parstype"
#pragma link "Vars"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
void __fastcall _MySum(PParserOperation AnOper)
{
   *(AnOper->Dest) = 0;
   for (int i = 1; i<=AnOper->ArgCnt; i++)
   {
      *(AnOper->Dest) += *(*(AnOper->Args)[i-1]);
   }
}
//---------------------------------------------------------------------------
Extended __fastcall _MyAVG(const ArgArray &Params, const int Param_High)
{
  Extended Result = 0;
  for (int i=0; i<=Param_High;i++) Result += Params[i];
  if (Param_High==-1) return 0;
  else return Result/(Param_High+1);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ShowResult(TLabel *ALabel, Extended AValue)
{
   if (dynamic_cast<TLabel*> (ALabel)) ((TLabel *)(ALabel))->Caption=FloatToStr(AValue);
}

//---------------------------------------------------------------------------

Extended __fastcall TForm1::EPVars1VAR1CalcValue(TVariable *Sender)
{
  return 40;
}
//---------------------------------------------------------------------------
Extended __fastcall TForm1::EPRegFuncs1MYPRODEvaluate(
      const ArgArray &Params, const int Param_High)
{
  Extended Result=0;
  if (Param_High>=0)
  {
     Result=1;
     for (int i=0; i<=Param_High; i++) Result *= Params[i];
  }
  return Result;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   typedef void (TObject:: *pom)();
   typedef void **ppp;
   pom p=(pom)&TForm1::ShowResult;
   InitVal=10;
   EPRegFuncs1->AddFunction("MySum",_MySum, -1, /*Unlimited number of arguments*/"My SUM function",fct_Aggregate);
   EPRegFuncs1->AddStdFunction("MyAVG",_MyAVG, OPENARRAY(TEPTypesType,(typeArray)),
                               typeExtended, "My AVG function", fct_Aggregate);
   EPRegFuncs1->AddClassFunction("ShowResult",*((ppp)&p), this,
                               OPENARRAY(TEPTypesType,(typeLongInt,typeExtended)), typeVoid ,
                                 "Outputs a value in a label''s caption", fct_Custom);
   Table1->Open();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   ExParser1->EditVariables();
   /*EPVars1.EditVariables;*/
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   EPUserLib1->Edit();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   EPUserLib1->IniFile = "";
   //If a Path is not specified, INI file must be in the Windows directory
   EPUserLib1->IniFile = "DEMOLIB.INI";
}
//---------------------------------------------------------------------------

void AddUserLibExpr(TEPExprList *AList, AnsiString AName, AnsiString AExpr)
{
  TStrings *ASrc;
  int AnIdx;
  ASrc = new TStringList;
  try
    {
    ASrc->Add(AExpr);
    if (AList->Find(AName,AnIdx)) AList->Sources[AnIdx]=ASrc;
    else AList->Add(AName,ASrc);
    }
  __finally { delete ASrc; }
}

//---------------------------------------------------------------------------


void __fastcall TForm1::Button6Click(TObject *Sender)
{
  ExParser1->Expression->Assign(Memo1->Lines);
  ResultLbl->Caption=FloatToStr(ExParser1->F(OPENARRAY(long double,(3,2,4))));
}
//---------------------------------------------------------------------------


Extended __fastcall TForm1::ExParser1Variable(TObject *Sender,
      const AnsiString VarName)
{
   int AnIdx;
   if (VarName==UpperCase("x2")) return 5;
   else if (VarName=="Y2") return 3;
   if (VarName==UpperCase("x2")) return 5;
   else if (ExParser1->UsedVariables->Find(VarName,AnIdx))
     return ExParser1->UsedVariables->Value[AnIdx];
   else return 0;
}
//---------------------------------------------------------------------------

Extended __fastcall TForm1::ExParser1Function(TObject *Sender,
      const AnsiString FuncName, const ArgArray &FuncParams,
      const int Param_High)
{
   Extended Result = 0;
   if (FuncName==UpperCase("MyFunc"))
      Result=FuncParams[0]*FuncParams[1]+FuncParams[2];
   else if (FuncName==UpperCase("MyFunc1"))
      Result=pow(FuncParams[0],2)+FuncParams[1];
   else if (FuncName==UpperCase("MySumFunc"))
     for (int i=0; i<=Param_High; i++) Result+=FuncParams[i];
   else
     throw Exception("Unknown function name: "+FuncName);
   return Result;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   TUsedVarsEditDlg *ADlg;
   ExParser1->Expression->Assign(Memo1->Lines);
   ADlg = new TUsedVarsEditDlg(this);
   try
     {
     ADlg->AnExParser=ExParser1;
     ADlg->ShowModal();
     }
   __finally { delete ADlg; };
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  ResultLbl->Caption="0"; ResultLbl2->Caption="";
  EPVars1->Variables["x1"]->Value = 4;
  EPVars1->Variables["y1"]->Value = 3;
  AddUserLibExpr(EPUserLib1->Aliases,"x","%0");
  EPUserLib1->Aliases->AddExpr("y","%1");
  EPUserLib1->Aliases->AddExpr("z","%2");
  EPUserLib1->UserFuncs->AddExpr("LibFunc1","x + y^3");
  EPUserLib1->UserFuncs->AddExpr("LibFunc2","LibFunc1(x,y)^2");
  Memo1->Lines->Clear();
  Memo1->Lines->Add("x1 ^ y1 + MySum(MyFunc(x,y,z),MyFunc(x+4,y+1,z+9),");
  Memo1->Lines->Add("prod(x2,y2),MyFunc1(x2,y2),LibFunc2(x2,y2),x3^y3)");
  DescrLbl->Caption="A complex single line expression demo, that uses function arguments, user defined library"
                    " functions and aliases, variables and registered math procedure. "
                    " You can try to load other definitions for library functions from INI file.";
}
//----------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{
  ResultLbl->Caption="0"; ResultLbl2->Caption="";
  Memo1->Lines->Clear();
  Memo1->Lines->Add("ACount:=0;");
  Memo1->Lines->Add("Result:=0;");
  Memo1->Lines->Add("DFirst([Table1]);");
  Memo1->Lines->Add("while Not(DEOF([Table1])) do begin");
  Memo1->Lines->Add("   Result:=Result+[DataSource1].Value;");
  Memo1->Lines->Add("   ACount:=ACount+1;");
  Memo1->Lines->Add("   DNext([Table1]);");
  Memo1->Lines->Add("   if Result>100 then break;");
  Memo1->Lines->Add("end;");
  Memo1->Lines->Add("ShowResult([ResultLbl2], ACount);");
  DescrLbl->Caption="This demo shows using of runtime components, DB fields and functions,"
                      " while loop, and registered class functions (ShowResult). You can use BREAK for break the loop.";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
   ResultLbl->Caption="0"; ResultLbl2->Caption="";
   Memo1->Lines->Clear();
   Memo1->Lines->Add("Sum:=0; K:=3;");
   Memo1->Lines->Add("if k<5 then");
   Memo1->Lines->Add("  for I:=0 to 30 do begin");
   Memo1->Lines->Add("    if (I>=0) and (I<5) then Sum:=Sum+3");
   Memo1->Lines->Add("    else if (I>=5) and (I<20) then Sum:=Sum+5");
   Memo1->Lines->Add("    else if (I>=20) and (I<=30) then Sum:=Sum+10;");
   Memo1->Lines->Add("  end");
   Memo1->Lines->Add("else if k<10 then begin");
   Memo1->Lines->Add("  I:=0;");
   Memo1->Lines->Add("  repeat");
   Memo1->Lines->Add("    if (I>=0) and (I<10) then Sum:=Sum+4");
   Memo1->Lines->Add("    else if (I>=10) and (I<20) then Sum:=Sum+5");
   Memo1->Lines->Add("    else if (I>=20) and (I<=30) then Sum:=Sum+6;");
   Memo1->Lines->Add("    Inc(I);");
   Memo1->Lines->Add("  until I>30;");
   Memo1->Lines->Add("end else begin");
   Memo1->Lines->Add("  I:=0;");
   Memo1->Lines->Add("  while I<=30 do begin");
   Memo1->Lines->Add("    Sum:=Sum+10;");
   Memo1->Lines->Add("    Inc(I);");
   Memo1->Lines->Add("  end;");
   Memo1->Lines->Add("end;");
   Memo1->Lines->Add("Result:=Sum;");
   Memo1->Lines->Add("ShowResult([ResultLbl2],I);");
   DescrLbl->Caption="This demo is a complex script that uses many nested 'if then else' statements and loops.";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
   TVariable *AVar=EPVars1->Variables["RTVar"];
   ResultLbl->Caption="0"; ResultLbl2->Caption="";
   AVar->Descr="A link to a runtime variable";
   AVar->LinkTo(&InitVal);
   Memo1->Lines->Clear();
   Memo1->Lines->Add("I:=MyPROD(RTVar,4,5);");
   Memo1->Lines->Add("Result:=MySUM(3,Var1,5,MyAVG(2,3,4,5));");
   Memo1->Lines->Add("ShowResult([ResultLbl2], I);");
   DescrLbl->Caption="This is an example of using a runtime variables and registered functions, and 'on event' " \
                      "evaluated variables and registered functions.";
}

//---------------------------------------------------------------------------

